<?php
/*
        +-----------------------------------------------------------------------------+
        | ILIAS open source                                                           |
        +-----------------------------------------------------------------------------+
        | Copyright (c) 1998-2006 ILIAS open source, University of Cologne            |
        |                                                                             |
        | This program is free software; you can redistribute it and/or               |
        | modify it under the terms of the GNU General Public License                 |
        | as published by the Free Software Foundation; either version 2              |
        | of the License, or (at your option) any later version.                      |
        |                                                                             |
        | This program is distributed in the hope that it will be useful,             |
        | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
        | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
        | GNU General Public License for more details.                                |
        |                                                                             |
        | You should have received a copy of the GNU General Public License           |
        | along with this program; if not, write to the Free Software                 |
        | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        +-----------------------------------------------------------------------------+
*/

include_once('Auth/Auth.php');

/**
* Authentication against ILIAS database
*
* @author Stefan Meyer <smeyer.ilias@gmx.de>
* @version $Id$
*
* @ingroup ServicesAuthentication
*/
class ilAuthDB extends Auth
{
	/**
	 * Constructor
	 *
	 * @access public
	 */
	public function __construct()
	{
		global $ilClientIniFile;
		
		$auth_params = array(
						'dsn'		  => IL_DSN,
						'table'       => $ilClientIniFile->readVariable("auth", "table"),
						'usernamecol' => $ilClientIniFile->readVariable("auth", "usercol"),
						'passwordcol' => $ilClientIniFile->readVariable("auth", "passcol")
					);
		parent::Auth("DB", $auth_params,"",false);

		// Set callbacks
		$this->setCallbacks();
	}
	
	/** 
	 * Called from base class after successful login
	 *
	 * @param string username
	 */
	protected function loginObserver($a_username)
	{
		if(!strlen($_POST['password']))
		{
			$this->status = AUTH_WRONG_LOGIN;
			$this->logout();
			return false;
		}
		return true;
	}
	
	/**
	 * Called from base class after wrong login
	 *
	 * @access protected
	 * @param
	 * @return
	 */
	protected function failedLoginObserver()
	{
		return false;
	}
	
	/** 
	 * Set callback function for PEAR Auth 
	 *
	 */
	private function setCallbacks() 
	{
		$this->setLoginCallback(array($this,'loginObserver'));
		$this->setFailedLoginCallback(array($this,'failedLoginObserver'));
	}
	
}
?>